- Home
- API Enriched
- Network Security
- config
- Replace Policy based Routing.
Replace Policy based Routing.
const url = 'https://example-corp.console.ves.volterra.io/api/v1/api/production/us-east-1/namespaces/default/api/config/namespaces/example/policy_based_routings/example';const options = { method: 'PUT', headers: {Authorization: '<Authorization>', 'Content-Type': 'application/json'}, body: '{"metadata":{"annotations":{},"description":"example","disable":true,"labels":{},"name":"example","namespace":"example"},"spec":{"forward_proxy_pbr":{"forward_proxy_pbr_rules":[{"all_destinations":{},"all_sources":{},"forwarding_class_list":[{"name":"example","namespace":"example"}],"http_list":{"http_list":[{"any_path":{},"exact_value":"example","path_exact_value":"example","path_prefix_value":"example","path_regex_value":"example","regex_value":"example","suffix_value":"example"}]},"ip_prefix_set":{"name":"example","namespace":"example"},"label_selector":{"expressions":["example"]},"metadata":{"description":"example","name":"example"},"prefix_list":{"prefixes":["example"]},"tls_list":{"tls_list":[{"exact_value":"example","regex_value":"example","suffix_value":"example"}]}}]},"forwarding_class_list":[{"name":"example","namespace":"example"}],"network_pbr":{"any":{},"label_selector":{"expressions":["example"]},"network_pbr_rules":[{"all_tcp_traffic":{},"all_traffic":{},"all_udp_traffic":{},"any":{},"applications":{"applications":["APPLICATION_HTTP"]},"dns_name":"example","forwarding_class_list":[{"name":"example","namespace":"example"}],"ip_prefix_set":{"ref":[{"name":"example","namespace":"example"}]},"metadata":{"description":"example","name":"example"},"prefix_list":{"prefixes":["example"]},"protocol_port_range":{"port_ranges":["example"],"protocol":"example"}}],"prefix_list":{"prefixes":["example"]}}}}'};
try { const response = await fetch(url, options); const data = await response.json(); console.log(data);} catch (error) { console.error(error);}curl --request PUT \ --url https://example-corp.console.ves.volterra.io/api/v1/api/production/us-east-1/namespaces/default/api/config/namespaces/example/policy_based_routings/example \ --header 'Authorization: <Authorization>' \ --header 'Content-Type: application/json' \ --data '{ "metadata": { "annotations": {}, "description": "example", "disable": true, "labels": {}, "name": "example", "namespace": "example" }, "spec": { "forward_proxy_pbr": { "forward_proxy_pbr_rules": [ { "all_destinations": {}, "all_sources": {}, "forwarding_class_list": [ { "name": "example", "namespace": "example" } ], "http_list": { "http_list": [ { "any_path": {}, "exact_value": "example", "path_exact_value": "example", "path_prefix_value": "example", "path_regex_value": "example", "regex_value": "example", "suffix_value": "example" } ] }, "ip_prefix_set": { "name": "example", "namespace": "example" }, "label_selector": { "expressions": [ "example" ] }, "metadata": { "description": "example", "name": "example" }, "prefix_list": { "prefixes": [ "example" ] }, "tls_list": { "tls_list": [ { "exact_value": "example", "regex_value": "example", "suffix_value": "example" } ] } } ] }, "forwarding_class_list": [ { "name": "example", "namespace": "example" } ], "network_pbr": { "any": {}, "label_selector": { "expressions": [ "example" ] }, "network_pbr_rules": [ { "all_tcp_traffic": {}, "all_traffic": {}, "all_udp_traffic": {}, "any": {}, "applications": { "applications": [ "APPLICATION_HTTP" ] }, "dns_name": "example", "forwarding_class_list": [ { "name": "example", "namespace": "example" } ], "ip_prefix_set": { "ref": [ { "name": "example", "namespace": "example" } ] }, "metadata": { "description": "example", "name": "example" }, "prefix_list": { "prefixes": [ "example" ] }, "protocol_port_range": { "port_ranges": [ "example" ], "protocol": "example" } } ], "prefix_list": { "prefixes": [ "example" ] } } } }'Shape of the Network Policy based routing replace specification.
Authorizations
Section titled “Authorizations”Parameters
Section titled “Parameters”Path Parameters
Section titled “Path Parameters”Namespace This defines the workspace within which each the configuration object is to be created. Must be a DNS_LABEL format. For a namespace object itself, namespace value will be ""
Name The configuration object to be replaced will be looked up by name.
Request Bodyrequired
Section titled “Request Bodyrequired”This is the input message of the ‘Replace’ RPC.
object
object
Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects.
object
Human readable description for the object.
A value of true will administratively disable the object.
Map of string keys and values that can be used to organize and categorize (scope and select) objects as chosen by the user. Values specified here will be used by selector expression.
object
This is the name of configuration object. It has to be unique within the namespace. It can only be specified during create API and cannot be changed during replace API. The value of name has to follow DNS-1035 format. Required: YES.
This defines the workspace within which each the configuration object is to be created. Must be a DNS_LABEL format. For a namespace object itself, namespace value will be ""
object
object
Network(L3/L4) routing policy rules.
URL(s) and domains policy for forward proxy for a connection type (TLS or HTTP)
object
object
object
Ordered list of forwarding Class to be used if no rule match.
Required: YES.
This type establishes a direct reference from one object(the referrer) to another(the referred). Such a reference is in form of tenant/namespace/name.
object
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name. Required: YES.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then tenant will hold the referred object’s(e.g. Route’s) tenant.
object
URLs for HTTP connections.
URL strings in form “HTTP://
object
object
Exclusive with [regex_value suffix_value] Exact domain name.
Exclusive with [any_path path_prefix_value path_regex_value] Exact Path to match.
Exclusive with [any_path path_exact_value path_regex_value] Prefix of Path e.g “/abc/xyz” will match “/abc/xyz/.*”
Exclusive with [any_path path_exact_value path_prefix_value] Regular Expression value for the Path to match.
Exclusive with [exact_value suffix_value] Regular Expression value for the domain name.
Exclusive with [exact_value regex_value] Suffix of domain names e.g “xyz.com” will match “*.xyz.com”
object
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name. Required: YES.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then tenant will hold the referred object’s(e.g. Route’s) tenant.
object
Expressions contains the Kubernetes style label expression for selections. Required: YES.
object
Human readable description.
This is the name of the message. The value of name has to follow DNS-1035 format. Required: YES.
object
List of IPv4 prefixes that represent an endpoint.
object
Domains in SNI for TLS connections.
Domains names.
object
Exclusive with [regex_value suffix_value] Exact domain name.
Exclusive with [exact_value suffix_value] Regular Expression value for the domain name.
Exclusive with [exact_value regex_value] Suffix of domain name e.g “xyz.com” will match “*.xyz.com” and “xyz.com”
Ordered list of forwarding Class to be used if source application match and no rule match.
Required: YES.
This type establishes a direct reference from one object(the referrer) to another(the referred). Such a reference is in form of tenant/namespace/name.
object
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name. Required: YES.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then tenant will hold the referred object’s(e.g. Route’s) tenant.
object
object
object
Expressions contains the Kubernetes style label expression for selections. Required: YES.
Network(L3/L4) routing policy rule.
Shape of Network PBR Rule.
object
object
object
object
object
object
Application protocols like HTTP, SNMP.
Exclusive with [any ip_prefix_set prefix_list] Resolve hostname to GET the IP.
Ordered list of forwarding Class to be used if rule match.
Required: YES.
This type establishes a direct reference from one object(the referrer) to another(the referred). Such a reference is in form of tenant/namespace/name.
object
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name. Required: YES.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then tenant will hold the referred object’s(e.g. Route’s) tenant.
object
A list of references to ip_prefix_set objects.
This type establishes a ‘direct reference’ from one object(the referrer) to another(the referred). Such a reference is in form of tenant/namespace/name for public API and Uid for private API This type of reference is called direct because the relation is explicit and concrete (as opposed to selector reference which builds a group based on labels of selectee objects)
object
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then kind will hold the referred object’s kind (e.g. “route”)
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then tenant will hold the referred object’s(e.g. Route’s) tenant.
When a configuration object(e.g. Virtual_host) refers to another(e.g route) then uid will hold the referred object’s(e.g. Route’s) uid.
object
Human readable description.
This is the name of the message. The value of name has to follow DNS-1035 format. Required: YES.
object
List of IPv4 prefixes that represent an endpoint.
object
List of port ranges. Each range is a single port or a pair of start and end ports e.g. 8080-8192.
Protocol in IP packet to be used as match criteria Values are TCP, UDP, and icmp.
object
List of IPv4 prefixes that represent an endpoint.
Responses
Section titled “Responses”A successful response.
object
Examplegenerated
{}Returned when operation is not authorized.
Examplegenerated
exampleReturned when there is no permission to access resource.
Examplegenerated
exampleReturned when resource is not found.
Examplegenerated
exampleReturned when operation on resource is conflicting with current value.
Examplegenerated
exampleReturned when operation has been rejected as it is happening too frequently.
Examplegenerated
exampleReturned when server encountered an error in processing API.
Examplegenerated
exampleReturned when service is unavailable temporarily.
Examplegenerated
exampleReturned when server timed out processing request.
Examplegenerated
example